package edu.stanford.cs147.magichw.magichw;

import android.content.Context;
import android.content.res.Configuration;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Typeface;
import android.net.Uri;
import android.os.Bundle;
import android.support.design.widget.FloatingActionButton;
import android.support.design.widget.Snackbar;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.text.style.ClickableSpan;
import android.view.LayoutInflater;
import android.view.View;
import android.support.design.widget.NavigationView;
import android.support.v4.view.GravityCompat;
import android.support.v4.widget.DrawerLayout;
import android.support.v7.app.ActionBarDrawerToggle;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.Menu;
import android.view.MenuItem;
import android.view.ViewGroup;
import android.widget.CheckBox;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.ToggleButton;
import android.content.Intent;
import android.text.SpannableString;
import android.text.Spanned;
import android.text.style.BackgroundColorSpan;
import android.text.TextPaint;
import android.text.method.LinkMovementMethod;
import android.os.CountDownTimer;

import java.io.Console;
import java.util.*;
import android.app.Dialog;
import android.widget.Button;
import android.graphics.drawable.ColorDrawable;

public class HomeScreen extends AppCompatActivity
                                implements fragmentHome.OnFragmentInteractionListener,
                                            fragmentAssignment.OnFragmentInteractionListener,
                                            gradedAssignmentOne.OnFragmentInteractionListener,
                                            pset3_welcome.OnFragmentInteractionListener,
                                            all_assignments.OnFragmentInteractionListener,
                                            resources_home.OnFragmentInteractionListener,
                                            settings.OnFragmentInteractionListener,
                                            assignment3.OnFragmentInteractionListener,
                                            PsychOneReview.OnFragmentInteractionListener,
                                            PerceptionPastQuestions.OnFragmentInteractionListener,
                                            fragmentStudyGuide.OnFragmentInteractionListener,
                                            contactScreen.OnFragmentInteractionListener{

    private DrawerLayout mDrawer;
    private Toolbar toolbar;
    private NavigationView nvDrawer;
    private ArrayList<TextView> helpTextViews;
    private Dialog myDialog;

    // Make sure to be using android.support.v7.app.ActionBarDrawerToggle version.
    // The android.support.v4.app.ActionBarDrawerToggle has been deprecated.
    private ActionBarDrawerToggle drawerToggle;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        // Set a Toolbar to replace the ActionBar.
        toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);

        // Find our drawer view
        mDrawer = (DrawerLayout) findViewById(R.id.drawer_layout);
        drawerToggle = setupDrawerToggle();

        mDrawer.addDrawerListener(drawerToggle);


        nvDrawer = (NavigationView) findViewById(R.id.nvView);
        // Setup drawer view
        setupDrawerContent(nvDrawer);

        Class fragmentClass = fragmentHome.class;
        Fragment fragment = null;
        try {
            fragment = (Fragment) fragmentClass.newInstance();
        } catch (Exception e) {
            e.printStackTrace();
        }

        FragmentManager fragmentManager = getSupportFragmentManager();
        fragmentManager.beginTransaction().replace(R.id.flContent, fragment).commit();

        setTitle("Home");

        myDialog = new Dialog(this);


    }



    @Override
    protected void onPostCreate(Bundle savedInstanceState) {
        super.onPostCreate(savedInstanceState);
        // Sync the toggle state after onRestoreInstanceState has occurred.
        drawerToggle.syncState();
    }

    @Override
    public void onConfigurationChanged(Configuration newConfig) {
        super.onConfigurationChanged(newConfig);
        // Pass any configuration change to the drawer toggles
        drawerToggle.onConfigurationChanged(newConfig);
    }


    private ActionBarDrawerToggle setupDrawerToggle() {
        return new ActionBarDrawerToggle(this, mDrawer, toolbar, R.string.drawer_open,  R.string.drawer_close);
    }

    private void setupDrawerContent(NavigationView navigationView) {
        navigationView.setNavigationItemSelectedListener(
                new NavigationView.OnNavigationItemSelectedListener() {
                    @Override
                    public boolean onNavigationItemSelected(MenuItem menuItem) {
                        selectDrawerItem(menuItem);
                        return true;
                    }
                });
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        if (drawerToggle.onOptionsItemSelected(item)) {
            onBackPressed();
            return true;
        }
        return super.onOptionsItemSelected(item);

    }


    public void selectDrawerItem(MenuItem menuItem) {
        // Create a new fragment and specify the fragment to show based on nav item clicked
        Fragment fragment = null;
        Class fragmentClass;
        switch(menuItem.getItemId()) {
            case R.id.homeButton:
                fragmentClass = fragmentHome.class;
                break;
            case R.id.assignmentsButton:
                fragmentClass = fragmentAssignment.class;
                break;
            case R.id.studyGuideButton:
                fragmentClass = fragmentStudyGuide.class;
                break;
            case R.id.resourcesButton:
                fragmentClass = resources_home.class;
                break;
            case R.id.settingsButton:
                fragmentClass = settings.class;
                break;
            default:
                fragmentClass = fragmentHome.class;
        }

        try {
            fragment = (Fragment) fragmentClass.newInstance();
        } catch (Exception e) {
            e.printStackTrace();
        }

        // Insert the fragment by replacing any existing fragment
        FragmentManager fragmentManager = getSupportFragmentManager();
        fragmentManager.beginTransaction().replace(R.id.flContent, fragment).addToBackStack("tag").commit();

        // Highlight the selected item has been done by NavigationView
        menuItem.setChecked(true);
        // Set action bar title
        setTitle(menuItem.getTitle());
        // Close the navigation drawer
        mDrawer.closeDrawers();
    }


    @Override
    public void onFragmentInteraction(Uri uri) {

    }

    public void goToGradedAssnOne(View view) {

        Class fragmentClass = gradedAssignmentOne.class;
        Fragment fragment = null;
        try {
            fragment = (Fragment) fragmentClass.newInstance();
        } catch (Exception e) {
            e.printStackTrace();
        }

        FragmentManager fragmentManager = getSupportFragmentManager();
        fragmentManager.beginTransaction().replace(R.id.flContent, fragment).addToBackStack("tag").commit();

    }


    public void goToAssn3(View view) {

        Class fragmentClass = pset3_welcome.class;
        Fragment fragment = null;
        try {
            fragment = (Fragment) fragmentClass.newInstance();
        } catch (Exception e) {
            e.printStackTrace();
        }

        FragmentManager fragmentManager = getSupportFragmentManager();
        fragmentManager.beginTransaction().replace(R.id.flContent, fragment).addToBackStack("tag").commit();

    }

    public void turnOnMagic(View view) {
        TextView assign3TextView = findViewById(R.id.assign3_q1_text);
        //Get the text from text view and create a spannable string
        SpannableString spannableString = new SpannableString(assign3TextView.getText());
        //Get the previous spans and remove them
        BackgroundColorSpan[] backgroundSpans = spannableString.getSpans(0, spannableString.length(), BackgroundColorSpan.class);
        ClickableSpan[] clickSpans = spannableString.getSpans(0, spannableString.length(), ClickableSpan.class);

        for (BackgroundColorSpan span : backgroundSpans) {
            spannableString.removeSpan(span);
        }

        for (ClickableSpan span : clickSpans) {
            spannableString.removeSpan(span);
        }


        //Search for all occurrences of the keyword in the string
        String input = "binary relations";
        int indexOfKeyword = spannableString.toString().indexOf(input);

        boolean checked = ((ToggleButton) view).isChecked();
        if (checked) {
            while (indexOfKeyword > 0) {
                //Create a background color span on the keyword
                spannableString.setSpan(new BackgroundColorSpan(getColor(R.color.colorPrimary)), indexOfKeyword, indexOfKeyword + input.length(), Spanned.SPAN_EXCLUSIVE_EXCLUSIVE);
                spannableString.setSpan(new ClickableSpan() {
                    @Override
                    public void onClick(View textView) {
                        ShowPopup(textView);
                    }
                    @Override
                    public void updateDrawState(TextPaint ds) {
                        super.updateDrawState(ds);
                        ds.setColor(getColor(R.color.colorPrimaryDark));
                    }
                }, indexOfKeyword, indexOfKeyword + input.length(), Spanned.SPAN_EXCLUSIVE_EXCLUSIVE);
                //Get the next index of the keyword
                indexOfKeyword = spannableString.toString().indexOf(input, indexOfKeyword + input.length());
            }
        }
        else
        {
            while (indexOfKeyword > 0) {
                //Create a background color span on the keyword
                spannableString.setSpan(false, indexOfKeyword, indexOfKeyword + input.length(), Spanned.SPAN_EXCLUSIVE_EXCLUSIVE);

                //Get the next index of the keyword
                indexOfKeyword = spannableString.toString().indexOf(input, indexOfKeyword + input.length());
            }
        }
        //Set the final text on TextView
        assign3TextView.setText(spannableString);
        assign3TextView.setClickable(true);
        assign3TextView.setMovementMethod(LinkMovementMethod.getInstance());
    }

    public void ShowPopup(View v) {
        TextView txtclose;
        myDialog.setContentView(R.layout.custompopuphelloworld);
        txtclose = myDialog.findViewById(R.id.txtclose);
        txtclose.setText("X");
        txtclose.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                myDialog.dismiss();
            }
        });
        myDialog.getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
        myDialog.show();
    }


    public void goToAllAssn(View view) {

        Class fragmentClass = all_assignments.class;
        Fragment fragment = null;
        try {
            fragment = (Fragment) fragmentClass.newInstance();
        } catch (Exception e) {
            e.printStackTrace();
        }

        FragmentManager fragmentManager = getSupportFragmentManager();
        fragmentManager.beginTransaction().replace(R.id.flContent, fragment).addToBackStack("tag").commit();

    }

    public void goToPsychOneReviewOne(View view) {

        Class fragmentClass = PsychOneReview.class;
        Fragment fragment = null;
        try {
            fragment = (Fragment) fragmentClass.newInstance();
        } catch (Exception e) {
            e.printStackTrace();
        }

        FragmentManager fragmentManager = getSupportFragmentManager();
        fragmentManager.beginTransaction().replace(R.id.flContent, fragment).addToBackStack("tag").commit();

    }

    public void goToPerceptionQuestions(View view) {

        Class fragmentClass = PerceptionPastQuestions.class;
        Fragment fragment = null;
        try {
            fragment = (Fragment) fragmentClass.newInstance();
        } catch (Exception e) {
            e.printStackTrace();
        }

        FragmentManager fragmentManager = getSupportFragmentManager();
        fragmentManager.beginTransaction().replace(R.id.flContent, fragment).addToBackStack("tag").commit();

    }

    public void pset3_start(View view) {

        Class fragmentClass = pset3_welcome.class;
        Fragment fragment = null;
        try {
            fragment = (Fragment) fragmentClass.newInstance();
        } catch (Exception e) {
            e.printStackTrace();
        }

        FragmentManager fragmentManager = getSupportFragmentManager();
        fragmentManager.beginTransaction().replace(R.id.flContent, fragment).addToBackStack("tag").commit();

    }

    public void pset3_assignment(View view) {
        Class fragmentClass = assignment3.class;
        Fragment fragment = null;
        try {
            fragment = (Fragment) fragmentClass.newInstance();
        } catch (Exception e) {
            e.printStackTrace();
        }

        FragmentManager fragmentManager = getSupportFragmentManager();
        fragmentManager.beginTransaction().replace(R.id.flContent, fragment).addToBackStack("tag").commit();

    }

    public void pset3_assignment_question1(View view) {
        Class fragmentClass = assignment3_question1.class;
        Fragment fragment = null;
        try {
            fragment = (Fragment) fragmentClass.newInstance();
        } catch (Exception e) {
            e.printStackTrace();
        }

        FragmentManager fragmentManager = getSupportFragmentManager();
        fragmentManager.beginTransaction().replace(R.id.flContent, fragment).addToBackStack("tag").commit();

    }

    public void expandAssignQ1(View view) {
        View expandedAnswer = (ViewGroup) this.findViewById(R.id.assign3_q1_expanded);
        expandedAnswer.setVisibility(View.VISIBLE);

        View extraSpace = (ViewGroup) this.findViewById(R.id.spaceForExpand);
        expandedAnswer.setVisibility(View.VISIBLE);

        View collapsedAnswer = (ViewGroup) this.findViewById(R.id.assign3_q1);
        collapsedAnswer.setVisibility(View.GONE);
    }


    public void collapseAssignQ1(View view) {
        View expandedAnswer = (ViewGroup) this.findViewById(R.id.assign3_q1_expanded);
        expandedAnswer.setVisibility(View.GONE);

        View extraSpace = (ViewGroup) this.findViewById(R.id.assign3_spaceForExpand);
        expandedAnswer.setVisibility(View.GONE);

        View collapsedAnswer = (ViewGroup) this.findViewById(R.id.assign3_q1);
        collapsedAnswer.setVisibility(View.VISIBLE);
    }


    public void expandView(View view) {
        View expandedAnswer = (ViewGroup) this.findViewById(R.id.secondQuestionExpanded);
        expandedAnswer.setVisibility(View.VISIBLE);

        View extraSpace = (ViewGroup) this.findViewById(R.id.assign3_spaceForExpand);
        expandedAnswer.setVisibility(View.VISIBLE);

        View collapsedAnswer = (ViewGroup) this.findViewById(R.id.secondQuestion);
        collapsedAnswer.setVisibility(View.GONE);
    }

    public void collapseView(View view) {
        View expandedAnswer = (ViewGroup) this.findViewById(R.id.secondQuestionExpanded);
        expandedAnswer.setVisibility(View.GONE);

        View extraSpace = (ViewGroup) this.findViewById(R.id.spaceForExpand);
        expandedAnswer.setVisibility(View.GONE);

        View collapsedAnswer = (ViewGroup) this.findViewById(R.id.secondQuestion);
        collapsedAnswer.setVisibility(View.VISIBLE);
    }

    public void expandUnitView(View view) {
        View expandedAnswer = (ViewGroup) this.findViewById(R.id.secondUnitExpanded);
        expandedAnswer.setVisibility(View.VISIBLE);

        View extraSpace = (ViewGroup) this.findViewById(R.id.spaceForExpand);
        expandedAnswer.setVisibility(View.VISIBLE);

        View collapsedAnswer = (ViewGroup) this.findViewById(R.id.secondUnit);
        collapsedAnswer.setVisibility(View.GONE);
    }

    public void collapseUnitView(View view) {
        View expandedAnswer = (ViewGroup) this.findViewById(R.id.secondUnitExpanded);
        expandedAnswer.setVisibility(View.GONE);

        View extraSpace = (ViewGroup) this.findViewById(R.id.spaceForExpand);
        expandedAnswer.setVisibility(View.GONE);

        View collapsedAnswer = (ViewGroup) this.findViewById(R.id.secondUnit);
        collapsedAnswer.setVisibility(View.VISIBLE);
    }


    //REVIEW EXPANDING AND COLLAPSING

    public void expandReviewP1View(View view) {
        View expandedAnswer = (ViewGroup) this.findViewById(R.id.firstQuestionReviewExpanded);
        expandedAnswer.setVisibility(View.VISIBLE);

        View extraSpace = (ViewGroup) this.findViewById(R.id.spaceForExpandR2);
        expandedAnswer.setVisibility(View.VISIBLE);

        View collapsedAnswer = (ViewGroup) this.findViewById(R.id.firstQuestionReview);
        collapsedAnswer.setVisibility(View.GONE);
    }

    public void collapseReviewP1View(View view) {
        View expandedAnswer = (ViewGroup) this.findViewById(R.id.firstQuestionReviewExpanded);
        expandedAnswer.setVisibility(View.GONE);

        View extraSpace = (ViewGroup) this.findViewById(R.id.spaceForExpandR2);
        expandedAnswer.setVisibility(View.GONE);

        View collapsedAnswer = (ViewGroup) this.findViewById(R.id.firstQuestionReview);
        collapsedAnswer.setVisibility(View.VISIBLE);
    }

    public void expandReviewP2View(View view) {
        View expandedAnswer = (ViewGroup) this.findViewById(R.id.secondQuestionReviewExpanded);
        expandedAnswer.setVisibility(View.VISIBLE);

        View extraSpace = (ViewGroup) this.findViewById(R.id.spaceForExpandR2);
        expandedAnswer.setVisibility(View.VISIBLE);

        View collapsedAnswer = (ViewGroup) this.findViewById(R.id.secondQuestionReview);
        collapsedAnswer.setVisibility(View.GONE);
    }

    public void collapseReviewP2View(View view) {
        View expandedAnswer = (ViewGroup) this.findViewById(R.id.secondQuestionReviewExpanded);
        expandedAnswer.setVisibility(View.GONE);

        View extraSpace = (ViewGroup) this.findViewById(R.id.spaceForExpandR2);
        expandedAnswer.setVisibility(View.GONE);

        View collapsedAnswer = (ViewGroup) this.findViewById(R.id.secondQuestionReview);
        collapsedAnswer.setVisibility(View.VISIBLE);
    }

    public void expandReviewP3View(View view) {
        View expandedAnswer = (ViewGroup) this.findViewById(R.id.thirdQuestionReviewExpanded);
        expandedAnswer.setVisibility(View.VISIBLE);

        View extraSpace = (ViewGroup) this.findViewById(R.id.spaceForExpandR2);
        expandedAnswer.setVisibility(View.VISIBLE);

        View collapsedAnswer = (ViewGroup) this.findViewById(R.id.thirdQuestionReview);
        collapsedAnswer.setVisibility(View.GONE);
    }

    public void collapseReviewP3View(View view) {
        View expandedAnswer = (ViewGroup) this.findViewById(R.id.thirdQuestionReviewExpanded);
        expandedAnswer.setVisibility(View.GONE);

        View extraSpace = (ViewGroup) this.findViewById(R.id.spaceForExpandR2);
        expandedAnswer.setVisibility(View.GONE);

        View collapsedAnswer = (ViewGroup) this.findViewById(R.id.thirdQuestionReview);
        collapsedAnswer.setVisibility(View.VISIBLE);
    }

    public void expandReviewP4View(View view) {
        View expandedAnswer = (ViewGroup) this.findViewById(R.id.fourthQuestionReviewExpanded);
        expandedAnswer.setVisibility(View.VISIBLE);

        View extraSpace = (ViewGroup) this.findViewById(R.id.spaceForExpandR2);
        expandedAnswer.setVisibility(View.VISIBLE);

        View collapsedAnswer = (ViewGroup) this.findViewById(R.id.fourthQuestionReview);
        collapsedAnswer.setVisibility(View.GONE);
    }

    public void collapseReviewP4View(View view) {
        View expandedAnswer = (ViewGroup) this.findViewById(R.id.fourthQuestionReviewExpanded);
        expandedAnswer.setVisibility(View.GONE);

        View extraSpace = (ViewGroup) this.findViewById(R.id.spaceForExpandR2);
        expandedAnswer.setVisibility(View.GONE);

        View collapsedAnswer = (ViewGroup) this.findViewById(R.id.fourthQuestionReview);
        collapsedAnswer.setVisibility(View.VISIBLE);
    }

    public void expandReviewP5View(View view) {
        View expandedAnswer = (ViewGroup) this.findViewById(R.id.fifthQuestionReviewExpanded);
        expandedAnswer.setVisibility(View.VISIBLE);

        View extraSpace = (ViewGroup) this.findViewById(R.id.spaceForExpandR2);
        expandedAnswer.setVisibility(View.VISIBLE);

        View collapsedAnswer = (ViewGroup) this.findViewById(R.id.fifthQuestionReview);
        collapsedAnswer.setVisibility(View.GONE);
    }

    public void collapseReviewP5View(View view) {
        View expandedAnswer = (ViewGroup) this.findViewById(R.id.fifthQuestionReviewExpanded);
        expandedAnswer.setVisibility(View.GONE);

        View extraSpace = (ViewGroup) this.findViewById(R.id.spaceForExpandR2);
        expandedAnswer.setVisibility(View.GONE);

        View collapsedAnswer = (ViewGroup) this.findViewById(R.id.fifthQuestionReview);
        collapsedAnswer.setVisibility(View.VISIBLE);
    }
    public void expandReviewP6View(View view) {
        View expandedAnswer = (ViewGroup) this.findViewById(R.id.sixthQuestionReviewExpanded);
        expandedAnswer.setVisibility(View.VISIBLE);

        View extraSpace = (ViewGroup) this.findViewById(R.id.spaceForExpandR2);
        expandedAnswer.setVisibility(View.VISIBLE);

        View collapsedAnswer = (ViewGroup) this.findViewById(R.id.sixthQuestionReview);
        collapsedAnswer.setVisibility(View.GONE);
    }

    public void collapseReviewP6View(View view) {
        View expandedAnswer = (ViewGroup) this.findViewById(R.id.sixthQuestionReviewExpanded);
        expandedAnswer.setVisibility(View.GONE);

        View extraSpace = (ViewGroup) this.findViewById(R.id.spaceForExpandR2);
        expandedAnswer.setVisibility(View.GONE);

        View collapsedAnswer = (ViewGroup) this.findViewById(R.id.sixthQuestionReview);
        collapsedAnswer.setVisibility(View.VISIBLE);
    }

    public void ReviewCategoryEditMode(View view){
        View categoryCheckBoxes = (ViewGroup) this.findViewById(R.id.reviewCategorySelection);
        categoryCheckBoxes.setVisibility(View.VISIBLE);

        Button editconfirmButton = this.findViewById(R.id.editConfirmButton);
        editconfirmButton.setText("Confirm");
        editconfirmButton.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                setVisibleQuestions(v);
            }
        });
    }

    public void setVisibleQuestions(View view){
        collapseReviewP1View(view);
        collapseReviewP4View(view);

        CheckBox checkBoxSens = (CheckBox) findViewById(R.id.sensationCheckBox);
        if (!checkBoxSens.isChecked()) {
            View collapsedAnswer1 = (ViewGroup) this.findViewById(R.id.firstQuestionReview);
            collapsedAnswer1.setVisibility(View.GONE);

            View collapsedAnswer4 = (ViewGroup) this.findViewById(R.id.fourthQuestionReview);
            collapsedAnswer4.setVisibility(View.GONE);
        }

        collapseReviewP2View(view);
        CheckBox checkBoxEn = (CheckBox) findViewById(R.id.EnergyCheckBox);
        if (!checkBoxEn.isChecked()) {
            View collapsedAnswer2 = (ViewGroup) this.findViewById(R.id.secondQuestionReview);
            collapsedAnswer2.setVisibility(View.GONE);
        }

        collapseReviewP3View(view);
        collapseReviewP5View(view);
        collapseReviewP6View(view);
        CheckBox checkBoxThr = (CheckBox) findViewById(R.id.ThresholdCheckBox);
        if (!checkBoxThr.isChecked()){
            View collapsedAnswer3 = (ViewGroup) this.findViewById(R.id.thirdQuestionReview);
            collapsedAnswer3.setVisibility(View.GONE);

            View collapsedAnswer5 = (ViewGroup) this.findViewById(R.id.fifthQuestionReview);
            collapsedAnswer5.setVisibility(View.GONE);

            View collapsedAnswer6 = (ViewGroup) this.findViewById(R.id.sixthQuestionReview);
            collapsedAnswer6.setVisibility(View.GONE);
        }

        View categoryCheckBoxes = (ViewGroup) this.findViewById(R.id.reviewCategorySelection);
        categoryCheckBoxes.setVisibility(View.GONE);

        Button editconfirmButton = this.findViewById(R.id.editConfirmButton);
        editconfirmButton.setText("Add/Edit");
        editconfirmButton.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                ReviewCategoryEditMode(v);
            }
        });
    }


    // THIS IS HOW YOU SHOW A TOAST (MESSAGE)
    public void showMessageAssign1(View view) {
        Toast.makeText(this.getApplicationContext(), "Click expand on problem 2!", Toast.LENGTH_SHORT).show();
    }

    public void showMessageReview(View view) {
        Toast.makeText(this.getApplicationContext(), "Click expand on Unit 2!", Toast.LENGTH_SHORT).show();
    }

    public void showMessageAssign3(View view) {
        Toast.makeText(this.getApplicationContext(), "Click expand on problem 1!", Toast.LENGTH_SHORT).show();
    }

    public void explainAI(View view) {
        final Toast tag = Toast.makeText(getBaseContext(), "Our state of the art AI has sorted the units based on an algorithm weighing your past performance on the material and the prevalence of that topic on the exam. \n\nThe material that the AI recommends for you has been presented first.",Toast.LENGTH_SHORT);

        tag.show();

        new CountDownTimer(9000, 600)
        {

            public void onTick(long millisUntilFinished) {tag.show();}
            public void onFinish() {tag.show();}

        }.start();
    }

    public void explainMatch(View view) {
        final Toast tag = Toast.makeText(getBaseContext(), "Our matching algorithm has optimally paired you with a student according to problems you struggled on that they got right, and vice versa.",Toast.LENGTH_SHORT);

        tag.show();

        new CountDownTimer(9000, 500)
        {

            public void onTick(long millisUntilFinished) {tag.show();}
            public void onFinish() {tag.show();}

        }.start();
    }



    public void messageViewOtherPset(View view) {
        Toast.makeText(this.getApplicationContext(), "View PSET 1!", Toast.LENGTH_SHORT).show();
    }

    public void notImplemented(View view) {
        Toast.makeText(this.getApplicationContext(), "This functionality has not been implemented.", Toast.LENGTH_SHORT).show();
    }


    public void moveToConnectPage(View view) {
        Class fragmentClass = contactScreen.class;
        Fragment fragment = null;
        try {
            fragment = (Fragment) fragmentClass.newInstance();
        } catch (Exception e) {
            e.printStackTrace();
        }

        FragmentManager fragmentManager = getSupportFragmentManager();
        fragmentManager.beginTransaction().replace(R.id.flContent, fragment).commit();
    }

    public void goToSecondContact(View view) {
        View firstContact = (ViewGroup) this.findViewById(R.id.firstContact);
        firstContact.setVisibility(View.GONE);

        View secondContact = (ViewGroup) this.findViewById(R.id.secondContact);
        secondContact.setVisibility(View.VISIBLE);
    }


    public void goToFirstContact(View view) {
        View firstContact = (ViewGroup) this.findViewById(R.id.firstContact);
        firstContact.setVisibility(View.VISIBLE);

        View secondContact = (ViewGroup) this.findViewById(R.id.secondContact);
        secondContact.setVisibility(View.GONE);
    }

    public void goToAddingVideo(View view) {
        Uri uri = Uri.parse("https://www.youtube.com/watch?v=OOcclZ8ucrU&t=75s"); // missing 'http://' will cause crashed
        Intent intent = new Intent(Intent.ACTION_VIEW, uri);
        startActivity(intent);
    }

    public void goToAdditionWebsite(View view) {
        Uri uri = Uri.parse("https://www.mathsisfun.com/numbers/addition.html"); // missing 'http://' will cause crashed
        Intent intent = new Intent(Intent.ACTION_VIEW, uri);
        startActivity(intent);
    }

    public void goToGradescope(View view) {
        Uri uri = Uri.parse("https://www.gradescope.com"); // missing 'http://' will cause crashed
        Intent intent = new Intent(Intent.ACTION_VIEW, uri);
        startActivity(intent);
    }
}
